precision highp float;
attribute vec4 position;
attribute vec4 inputTextureCoordinate;

const int MAX_NUM_OF_TOUCH = 2;
const float EFFECT_DELAY_TIME = 0.1;

uniform highp vec2 iResolution;
uniform highp float iGlobalTime;
uniform float startTime[MAX_NUM_OF_TOUCH];
uniform  vec2 touchPosition[MAX_NUM_OF_TOUCH];
uniform highp float duration;
uniform int currentIndex;

varying float elapseFactor[MAX_NUM_OF_TOUCH];
varying float elapseDelayFactor[MAX_NUM_OF_TOUCH];
varying float isTouchDraw[MAX_NUM_OF_TOUCH];
varying float isTouchDelayDraw[MAX_NUM_OF_TOUCH];
varying vec2 textureCoordinate;
varying vec2 x_y_proportion;
//varying float waveAlphaFactor;


float times = 5.0;
void main()
{
    float elapsedTime[MAX_NUM_OF_TOUCH];
    float elapseDelayTime[MAX_NUM_OF_TOUCH];
    float delayDuration = duration - EFFECT_DELAY_TIME;
    float waveDuration =times*duration;
    x_y_proportion = vec2(iResolution.x/iResolution.y,1.0);
    for(int i =0;i<MAX_NUM_OF_TOUCH;i++){
//         newTouchPosition[i] = touchPosition[i]*x_y_proportion;
         elapsedTime[i] = iGlobalTime - startTime[i];

//         if(i==currentIndex){
//                 if(elapsedTime[i]<= waveDuration*0.6){
//                       waveAlphaFactor = 1.0-smoothstep(0.0,1.0,fract(elapsedTime[i]/waveDuration));
//                 }
//                 else{
//                        waveAlphaFactor = 0.4;
//                 }
//
//         }

         // stretch wave
         if(elapsedTime[i]<=duration && elapsedTime[i]>0.0&&startTime[i]!=0.0){
            isTouchDraw[i]=1.0;
            elapseFactor[i] = smoothstep(0.0,1.0,fract(elapsedTime[i]/duration));
         }
         else{
            elapseFactor[i] = 0.0;
            isTouchDraw[i]=0.0;
         }
         elapseDelayTime[i] = elapsedTime[i]-EFFECT_DELAY_TIME;
         if(elapseDelayTime[i]<= delayDuration&&elapseDelayTime[i]>0.0&&startTime[i]!=0.0){
            isTouchDelayDraw[i] = 1.0;
            elapseDelayFactor[i] = smoothstep(0.0,1.0,fract(elapseDelayTime[i]/delayDuration));
         }
         else{
            isTouchDelayDraw[i] = 0.0;
            elapseDelayFactor[i] = 0.0;
         }
    }
    gl_Position = position;
    textureCoordinate = inputTextureCoordinate.xy;
}