precision highp float;
uniform mat4 u_Matrix;
uniform highp float iGlobalTime;                   // 当前系统的时间

attribute vec3 a_Position;
attribute vec3 a_Color;
attribute vec3 a_DirectionVector;
attribute float a_ParticleStartTime;    // 粒子创建的时间
attribute float a_PointSizeScale;

varying float v_ElapsedTime;
varying vec3 v_Color;

void main() {
    v_Color = a_Color;
    v_ElapsedTime = iGlobalTime - a_ParticleStartTime;

    vec3 currentPosition = a_Position + (a_DirectionVector * v_ElapsedTime);

    float gravityFactor = v_ElapsedTime * v_ElapsedTime / 9.8;
    currentPosition.y -= gravityFactor;

    gl_Position = u_Matrix * vec4(currentPosition, 1.0);
    gl_PointSize = 40.0*clamp(v_ElapsedTime,0.2,1.0)*clamp(a_PointSizeScale,0.5,1.0);

}